import { defineComponent } from "vue";
import { bool, string } from "vue-types";
import { useCompData } from ".";
import { useEditor } from "../../../..";
import { DesignComp } from "../../../../objects/DesignTemp/DesignComp";
import { View } from "../View";
import { CompUI } from "../..";
import { SelectTransfer } from "../Transfer/select";
import { sortedArray } from "three/src/animation/AnimationUtils";

export const Component = defineComponent({
  props: {
    compId: string().isRequired,
    showMask: bool().def(false)
  },
  setup(props) {
    const { helper, controls , store} = useEditor();
    const { children } = useCompData(props.compId);

    const isStreamCard = helper.isStreamCard(props.compId);

    
    return () => (
      <View compId={props.compId} showMask={props.showMask}>
        {children.default?.map((compId) => {
          const compItem = helper.findComp(compId) as DesignComp;
          const Comp =
            controls.compUICtrl.state.components.get(compItem?.compKey)
              ?.Component || CompUI.Container.Component;

          return <Comp key={compItem.id} compId={compItem.id} />;
        })}
      </View>
    );
  },
});
