import { useEditor } from "@/modules/editor";
import { css } from "@linaria/core";
import { defineComponent, reactive } from "vue";
import { bool, string } from "vue-types";
import CateSelect from "./CateSelect";

export default defineComponent({
  props: {
    sourceType: string(),
    isSys: bool().def(true),
  },
  emits: ["change"],
  setup(props, { emit }) {
    const { controls } = useEditor();
    const state = reactive({
      values: [] as any,
    });
    const getCate = () => {
      const categories = props.isSys
        ? controls.categoryCtrl.state.syscategories
        : controls.categoryCtrl.state.categories;
      const currCate: any = categories.find((e: any) => {
        return e.value == props.sourceType?.toLowerCase();
      });

      return currCate?.children || [];
    };
    const cateChange = (v: string) => {
      state.values = v;
    };
    return () => {
      const options = getCate();
      if (options.length == 0) return null;
      return (
        <div class={rootStyle}>
          <CateSelect
            data={options}
            value={state.values}
            onChange={(v) => cateChange(v)}
          />
          {/* {options.slice(0, 2).map((d: any, i: number) => (
            <div class={"cate_item flex-1"}></div>
          ))} */}
          {/* <Tooltip
            visible={state.overlayVisible}
            placement="rightTop"
            trigger="click"
            title={renderOverlay()}
            onVisibleChange={toggleFilter}
          >
            <div class={btnStyle}>
              筛选
              <Icon type="filter" size="0.14rem" />
            </div>
          </Tooltip> */}
        </div>
      );
    };
  },
});

const rootStyle = css`
  display: flex;
  align-items: center;
  margin: 12px 0;
  .ant-cascader {
    width: 100%;
  }
  .cate_item {
    margin-left: 10px;
    &:first-child {
      margin-left: 0;
    }
  }
`;
