import { DesignComp } from "./DesignComp";
import { dataTransform } from "./versions/1.0.0";
import { dataTransform as V101Upgrade } from "./versions/1.0.1";

export type CardState = {
  id: string;
  children: {id:string, matrix: string, size: [number, number, { unit?: "px" | "%" }?]}[]
}

export class DesignTemp {
  version?: string;
  _id!: string;
  title = "";
  desc = "";
  pageStyle?: any;
  content: string[] = ["root"]; //rootPcShort rootPcNormal rootPcLong rootMobShort rootMobLong
  thumbnail?: string;
  compMap: { [compId: string]: DesignComp } = {};
  compScreenMap: {[Screen: string]: CardState[]} = {}

  constructor(data?: Partial<DesignTemp>) {
    if (!data) return;
    Object.assign(this, V101Upgrade(dataTransform(data)));
    // 初始化DesignComp
    Object.entries(this.compMap).forEach(([key, value]) => {
      this.compMap[key] = new DesignComp(value);
    });
    // 初始化DesignComp的pid
    Object.values(this.compMap).forEach((comp) => {
      if (comp.children.default) {
        // comp.children.default = Array.from(new Set(comp.children.default));
      }
      const childIds = comp.getChildIds();
      childIds.forEach((cid) => {
        const childComp = this.compMap[cid];
        // Object.defineProperty(childComp, "pid", { value: comp.id });
      });
    });
  }
}
