import { css } from "@linaria/core";

import { defineComponent } from "vue";

import { useEditor } from "@/modules/editor";
import CategoryTree from "./CategoryTree";

export default defineComponent({
  setup() {
    const { controls } = useEditor();

    return () => {
      return (
        <div>
          <h3 class={"text-22px"}>我的分类</h3>
          <div class={CategoryView}>
            <CategoryTree data={controls.categoryCtrl.state.categories} />
          </div>
        </div>
      );
    };
  },
});

const CategoryView = css`
  display: flex;
  margin-top: 30px;
  background-color: @inf-component-bg;
`;
